#include <iostream>
#include <iomanip>


using namespace std;

class Base
{
public:
	Base()
	{
		val = 0x42;
		cout << "Base::Base()" << endl;
	}

	void nonVirtual()
	{
		cout << "Base::nonVirtual()" << endl;
	}

	virtual void isVirtual()
	{
		cout << "Base::isVirtual()" << endl;
	}

	virtual void secondVirtual()
	{
		cout << "Base::secondVirtual()" << endl;
	}

	int	val;
};


class Derived : public Base
{
public:
	Derived()
	{
		val = 0x99887766;
		cout << "Derived::Derived()" << endl;
	}

	virtual void isVirtual()
	{
		cout << "Derived::isVirtual()" << endl;
	}
};

void f(Base &b)
{
	b.isVirtual();
	b.secondVirtual();
}

int main()
{
	Base	b;

	cout << "Base at 0x" << setw(8) << setfill('0') << &b << endl;
	b.nonVirtual();
	b.isVirtual();
	b.secondVirtual();
	f(b);

	Derived	d;

	cout << "Derived at 0x" << setw(8) << setfill('0') << &d << endl;
	d.nonVirtual();
	d.isVirtual();
	d.secondVirtual();
	f(d);

	return 0;
}